###############################################################################
# Favor.pl                                                                    #
# Favorites Mod version 1.0 by DummyProof                                     #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.x                                        #
# Released:       December 2001; Updated January 27, 2003                     #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

sub favordrop {
	my(@dirdata,@datdata,@threadlist,$filename,$entry,@entries,$boardname,$mnum2,$mnum,$dummy,$msub,$mname,$memail,$mdate,$musername,$micon,@found_number,@found_subject,@found_new,@found_board);

	# Read all .fav-Files and search for username
	opendir (DIRECTORY,"$datadir");
	@datdata = grep {/\.fav$/} readdir(DIRECTORY);
	closedir (DIRECTORY);

	# Load Censor List
	&LoadCensorList;
	
	foreach $filename (@datdata) {
		fopen(FILE, "$datadir/$filename");
		@entries = <FILE>;
		fclose(FILE);
		$boardname = $entries[0];
		chomp $boardname;
	        foreach $entry (@entries) {
	        	$entry =~ s/[\n\r]//g;
	        	if ($entry eq $username) {
				($mnum, $dummy) = split(/\./,$filename);

				fopen(FILE, "$boardsdir/$boardname.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.txt");
				@threadlist = <FILE>;
				fclose(FILE);
				foreach( @threadlist ) {
					my ($threaddate,$dlp,$new);
					($mnum2, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split( /\|/, $_ );
					if($mnum2 == $mnum) {
						# Decide if thread should have the "NEW" indicator next to it.
						# Do this by reading the user's log for last read time on thread,
						# and compare to the last post time on the thread.
						$dlp = &getlog($mnum2);
						$threaddate = stringtotime($mdate);
						if( $max_log_days_old && $dlp < $threaddate && $username ne 'Guest' && &getlog("$boardname--mark") < $threaddate ) {
							$new = qq~*NEW* ~;
							push(@num_new, "1");
						}
						else { $new = ''; }

						# Censor the subject of the thread.
						foreach (@censored) {
							($tmpa,$tmpb) = @{$_};
							$msub =~ s~\Q$tmpa\E~$tmpb~gi;
						}
						push(@found_board,$boardname);
						push(@found_number,$mnum2);
						push(@found_subject,$msub);
						push(@found_new,$new);

					}
				}
			}
		}
	}

	$newfavs = "$fav{'13'}";
	if (@found_number) {
		$numnew = scalar @num_new;
		if($numnew > 0){$newfavs = qq~ $numnew$fav{'14'}~;}
	# Build the dropdown

		$favselect = qq~
<form method="post" action="$scripturl" name="gofav">
<font size=2><b>$fav{'1'}: </b></font><select name="values" onChange="if(this.options[this.selectedIndex].value) window.location.href='$scripturl' + this.options[this.selectedIndex].value;">~;
		$favselect .= qq~
<option value="">$newfavs</option>
<option value="?action=favshow">$fav{'15'}</option>~;
		if (@found_number) {
			$favselect .= qq~
<option value=""></option>
<option value="">$fav{'16'}</option>
<option value="">--------------------------------</option>\n~;
			$counter=0;
			foreach $entry (@found_number) {
				$favselect .= qq~<option value="?board=$found_board[$counter];action=display;num=$found_number[$counter]">$found_new[$counter]$found_subject[$counter]</option>\n~;
				$counter++;
			}
		}
		$favselect .= qq~</select>~;
	}
}

sub Favor2 {
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	if($username eq 'Guest') { &fatal_error($txt{'138'}); }
	$board = $INFO{'board'};
	$thread = $INFO{'thread'};
	$start = $INFO{'start'} ne '' ? $INFO{'start'} : 9999999;
	fopen(FILE, "$datadir/$thread.fav");
	@names = <FILE>;
	fclose(FILE);

	# if there is only one entry and this is the address which is to remove, remove the file at all

	fopen(FILE, ">$datadir/$thread.fav", 1) || &fatal_error("$txt{'23'} $thread.fav");
	print FILE "$board\n";
	print FILE "$username\n";
	foreach $curname (@names) {
		$curname =~ s/[\n\r]//g;
		if(($username ne "$curname") && ($board ne "$curname")) { print FILE "$curname\n"; }
	}
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=display;num=$thread;start=$start~;
	&redirectexit;
}

sub Favor3 {
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	if($username eq "Guest") { &fatal_error("$txt{'138'}"); }
	$thread = $INFO{'thread'};
	$start = $INFO{'start'} ne '' ? $INFO{'start'} : 9999999;
	fopen(FILE, "$datadir/$thread.fav");
	@names = <FILE>;
	fclose(FILE);

	# if there is only one entry and this is the address which is to remove, remove the file at all

	if( @names == 2) {
		unlink("$datadir/$thread.fav");
	} else
	# make no change with the file
	{
	fopen(FILE, ">$datadir/$thread.fav", 1) || &fatal_error("$txt{'23'} $thread.fav");
	foreach $curname (@names) {
		$curname =~ s/[\n\r]//g;
		if($username ne $curname) { print FILE "$curname\n"; }
	}
	fclose(FILE);
	}
	$yySetLocation = qq~$cgi;action=display;num=$thread;start=$start~;
	&redirectexit;
}

sub Favor4 {
	if($username eq "Guest") { &fatal_error("$txt{'138'}"); }
	my( $variable, $dummy, $dummy2, $threadno, @names, $curname );

	foreach $variable (keys %FORM) {
	 	$dummy = $FORM{$variable};
		($dummy2,$threadno) = split(/-/,$variable);
		if ($dummy2 eq "thread") {

			fopen(FILE, "$datadir/$threadno.fav");
			@names = <FILE>;
			$boardname = $names[0];
			chomp $boardname;
			fclose(FILE);

			# if there is only one entry and this is the address which is to remove, remove the file at all
			if( @names <= 2) {
				unlink("$datadir/$threadno.fav");
			} else
			# make no change with the file
			{
			fopen(FILE, ">$datadir/$threadno.fav") || &fatal_error("$txt{'23'} $threadno.fav");
			print FILE "$boardname\n";
			foreach $curname (@names) {
				$curname =~ s/[\n\r]//g;
				if(($username ne $curname) && ($boardname ne $curname)) { print FILE "$curname\n"; }
			}
			fclose(FILE);
			}
		}
	}
	$yySetLocation = qq~$scripturl?action=favshow~;
	&redirectexit;
}

sub remove_favorites {
	my (@deaduser, @favdir, $filename, $content, $content_old) = (@_);

	opendir (DIRECTORY,"$datadir");
	@favdir = grep {/\.fav$/} readdir(DIRECTORY);
	closedir (DIRECTORY);

	foreach $filename (@favdir) {
		$content = '';

		fopen(MYFILE, "+<$datadir/$filename") || &fatal_error("$txt{'23'} $filename");
		while (<MYFILE>) { $content .= $_; }
		$content_old = $content;

		foreach (@deaduser) { $content =~ s/$_(?:\r\n|\r|\n)//ig; }

		if (length($content) > 1) {
			if ($content ne $content_old) {
				truncate(MYFILE,0);
				seek(MYFILE,0,0);
				print MYFILE $content;
				fclose(MYFILE);
				$done .= "$filename\n";
			}
			else {
				fclose(MYFILE);
			}
		}
		else {
			fclose(MYFILE);
			unlink("$datadir/$filename");
		}
	}
}

sub ShowFavors {
	if($username eq "Guest") { &fatal_error("$txt{'138'}"); }

	my(@dirdata,@datdata,@threadlist,$filename,$entry,@entries,$boardname,$mnum2,$mnum,$dummy,$msub,$mname,$memail,$mdate,$musername,$micon,$mattach,$mip,$mmessage,@messages,@found_number,@found_subject,@found_date,@found_mreplies,@found_views,@found_new,@found_micon,@found_lpost,@found_board,@found_name);

	# Read all .fav-Files and search for username
	opendir (DIRECTORY,"$datadir");
	@dirdata = readdir(DIRECTORY);
	closedir (DIRECTORY);
	@datdata = grep(/fav/,@dirdata);

	# Load Censor List
	&LoadCensorList;
	
	$i = 0;
	foreach $filename (@datdata) {
		fopen(FILE, "$datadir/$filename");
		@entries = <FILE>;
		fclose(FILE);
		$boardname = $entries[0];
		chomp $boardname;
	        foreach $entry (@entries) {
	        	$entry =~ s/[\n\r]//g;
	        	if ($entry eq $username) {
				($mnum, $dummy) = split(/\./,$filename);

				fopen(FILE, "$boardsdir/$boardname.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.txt");
				@threadlist = <FILE>;
				fclose(FILE);
				foreach( @threadlist ) {
					my ($threaddate,$dlp,$new);
					($mnum2, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split( /\|/, $_ );
					if($mnum2 == $mnum) {
						# Decide if thread should have the "NEW" indicator next to it.
						# Do this by reading the user's log for last read time on thread,
						# and compare to the last post time on the thread.
						$dlp = &getlog($mnum2);
						$threaddate = stringtotime($mdate);
						if( $max_log_days_old && $dlp < $threaddate && $username ne 'Guest' && &getlog("$boardname--mark") < $threaddate ) {
							$new = qq~<img src="$imagesdir/new.gif" alt="$txt{'302'}"> ~;
						}
						else { $new = ''; }
				
						# Load the current nickname of the account name of the thread starter.
						if( $musername ne 'Guest' && -e "$memberdir/$musername.dat" ) {
							&LoadUser($musername);
							$mname = $userprofile{$musername}->[1] || $mname || $txt{'470'};
							$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}" alt="$txt{'27'}: $musername">$mname</a>~;
						}
						else {
							$mname ||= $txt{'470'};
						}

						#italicize the subject if notification is on for this user 				
						if(-e "$datadir/$mnum2.mail")  {
							fopen(FILE, "$datadir/$mnum2.mail");
								@starter = <FILE>;
							fclose(FILE);
							foreach $alx (@starter) {
								$alx =~ s/[\n\r]//g;
								if($settings[2] eq "$alx") {$msub = qq~<i>$msub</i>~;}
							}
						}

						# Censor the subject of the thread.
						foreach (@censored) {
							($tmpa,$tmpb) = @{$_};
							$msub =~ s~\Q$tmpa\E~$tmpb~gi;
						}
				
						# Decide how many pages the thread should have.
						$threadlength = $mreplies + 1;
						$pages = '';
						if( $threadlength > $maxmessagedisplay ) {
							$tmpa = 1;
							for( $tmpb = 0; $tmpb < $threadlength; $tmpb += $maxmessagedisplay ) {
								$pages .= qq~<a href="$scripturl?board=$boardname;action=display;num=$mnum2;start=$tmpb">$tmpa</a>\n~;
								++$tmpa;
							}
							$pages =~ s/\n\Z//;
							$pages = qq~<BR><font size="1">&#171; $txt{'139'} $pages &#187;</font>~;
						}
				
						if( fopen(FILE, "$datadir/$mnum2.data") ) {
							$tmpa = <FILE>;
							fclose(FILE);
						}
						elsif( -e "$datadir/$mnum2.data" ) {
							&fatal_error("301 $txt{'106'}: $txt{'23'} $mnum2.data");
						}
						else {
							$tmpa = '0';
						}
				
				
						($views, $lastposter) = split(/\|/, $tmpa);
						if( $lastposter =~ m~\AGuest-(.*)~ ) {
							$lastposter = $1;
						}
						else {
							unless( $lastposter eq $txt{'470'} ) {
								$lastposterid = $lastposter;
								&LoadUser($lastposterid);
								if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
							}
							&LoadUser($lastposter);
						}
						$lastpostername = $lastposter || $txt{'470'};
						$views = $views ? $views - 1 : 0;
						$mydate = &timeformat($mdate);
						$foundlist2[$i] = qq~$boardname|$new|$views|$mreplies|$mname|$pages|$mydate|$msub|$mnum2|$lastpostername|$micon~;
						$i++;
					}
				}
			}
		}
	}

	# Display all Entries

	if (@foundlist2==0) {
	$yymain .= qq~
<table border="0" width="100%" cellspacing="1" cellpadding="6" bgcolor="$color{'bordercolor'}" class="bordercolor">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg">
   <img src="$imagesdir/favorite.gif" border="0">&nbsp;<font size="2" color="$color{'titletext'}" class="text1"><b>$fav{'1'}</b></font>
  </td>
 </tr><tr>
  <td align="center" bgcolor="$color{'windowbg'}" class="windowbg">
   <font size=2>
    <br><br>$fav{'4'}<br><br>
    </td>
  </tr>
</table>
~;
	} else {
	#sort the array by boardname, so we can display the favorites in groups by board
	@foundlist = map {$_->[0]} sort{lc($a->[1]) cmp lc($b->[1])} map { [ $_, (split /\|/)[0..12] ] } (@foundlist2);
		$yymain .= qq~
<center><img src="$imagesdir/favorite.gif" border="0">&nbsp;<font size=3><b>$fav{'5'}</b></font></center><br>
<form action="$cgi;action=favor4" method=post>
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="10%" colspan="2"><font size=2>&nbsp;</font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="48%"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'70'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="14%" align="center"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'109'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'110'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'301'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="27%"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'111'}</b></font></td>
      </tr>
~;
		$counter=0;
		foreach $entry (@foundlist) {
		my ($curboard, $new, $views, $mreplies, $mname, $pages, $mydate, $msub, $mnum2, $lastpostername, $micon) = split(/\|/, $foundlist[$counter]);
			if($curboard ne $brdshowed){
				# Get the board's description
				fopen(FILE, "$boardsdir/$curboard.dat");
				@boardinfo = <FILE>;
				fclose(FILE);
				chomp @boardinfo;
				$bdname = $boardinfo[0];
$yymain .= qq~
      <tr>
        <td colspan="7" align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%"><font size="2"><b>&nbsp;$bdname</b></font></td>
      </tr>
~;
				$brdshowed = $curboard;
			}
$yymain .= qq~
      <tr>
        <td class="windowbg2" valign="middle" align="center" width="6%" bgcolor="$color{'windowbg2'}"><input type=checkbox name="thread-$mnum2" value="1"></td>
        <td class="windowbg2" valign="middle" align="center" width="4%" bgcolor="$color{'windowbg2'}"><img src="$imagesdir/$micon.gif" alt="" border="0" align=middle></td>
        <td class="windowbg" valign="middle" width="48%" bgcolor="$color{'windowbg'}"><font size=2>$new<a href="$scripturl?board=$curboard;action=display;num=$mnum2"><b>$msub</b></a> $pages</font></td>
        <td class="windowbg2" valign="middle" align="center" width="14%" bgcolor="$color{'windowbg2'}"><font size="1">$mname</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}"><font size=2>$mreplies&nbsp;</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}"><font size=2>$views&nbsp;</font></td>
        <td class="windowbg2" valign="middle" width="27%" bgcolor="$color{'windowbg2'}"><font size="1">$mydate<br>$txt{'525'} $lastpostername</font></td>
      </tr>~;
			$counter++;
		}
		$yymain .= qq~
	</table>
	 <table border="0" width="100%" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor">
	  <tr>
	   <td align="center" class="catbg" bgcolor="$color{'catbg'}" width="100%">
	    <table border=0 cellspacing=0 cellpadding=0>
	     <tr>
	      <td align="center">
		<br><font size=2>$fav{'6'}</font><br>&nbsp;<br>
		<input type=reset value="$txt{'278'}">&nbsp;&nbsp;&nbsp;<input type=submit value="$fav{'7'}"><br><br>
	      </td>
	     </tr>
	    </table>
	   </td>
	  </tr>
	  </form>
	 </table>
	</table>~;
	}
	$yytitle = "$fav{'7'}";
	&template;
	exit;
}

sub favmovecheck { 
	my ( $curuser, $favboard ) = @_;
	#get the boards parent category
	fopen(CATFILE, "$boardsdir/$favboard.ctb");
	$favcat = <CATFILE>;
	fclose(CATFILE);
	chomp $favcat;

	#get the membergroups that have access to the category.
	fopen(FILE, "$boardsdir/$favcat.cat") || &fatal_error("$txt{'23'} $favcat.cat");
	@catinfo = <FILE>;
	fclose(FILE); 
	chomp $catinfo[1];
	(@curcatgroups) = split(/\,/, $catinfo[1]);

	@memsettings = ();
	$accessfav = 0; 
	#here we find out if the member is allowed access to the new category the thread
	#with favorite is being moved to. 
	if(@curcatgroups){
		fopen(FILE, "$memberdir/$curuser.dat");
		@memsettings=<FILE>;
		fclose(FILE); 
		$memsettings[7] =~ s~[\n\r]~~g;
		chomp $memsettings[7]; 
		foreach $cur (@curcatgroups) { 
			chomp $cur; 
			if ($cur ne '') { 
			if ($cur eq $memsettings[7] || $memsettings[7] eq "Administrator" || $memsettings[7] eq "Global Moderator" ) { $accessfav = 1; last;}
			} 
		} 
	} else {
		$accessfav = 1;
	}
	return $accessfav;
}

1;
