<id>
Favorites Lists SP1.1/SP1.2
</id>

<version>
1.0 SP1.1/SP1.2
</version>

<mod info>
Allows for Members to maintain a "Favorites List" of their favorite Topics.
A "Favorites List" dropdown box is also available if the admin allows the members to 
use it.(why wouldn't you!?) A "new" label is shown next to any thread in the dropdown 
box that has a new post in the thread.

Upload the 2 "gif" files to your YaBBImages dir, Favor.pl to the Sources dir and 
the modified files after installing the mod file.
After installing the mod and uploading the modified and new files, enable the Favorites
feature(and the Favorites dropdown selector) in "Forum Preferences and Settings". 

Files Modified:
english.lng
YaBB.pl
Sources/Subs.pl
Sources/Admin.pl
Sources/AdminEdit.pl
Sources/Display.pl
Sources/Profile.pl
Sources/MoveThread.pl
Sources/RemoveThread.pl
Sources/RemoveOldThreads.pl
Sources/ModifyMessage.pl
Sources/ManageCats.pl
Sources/ManageBoards.pl
Sources/MessageIndex.pl
Sources/BoardIndex.pl

Files Added:
Sources/Favor.pl
YaBBImages/favorite.gif
YaBBImages/favorite2.gif

</mod info>

<author>
DummyProof
</author>

<homepage>
http://dummyyabb.sourceforge.net/cgi-bin/DYaBB2/YaBB.pl
</homepage>

<edit file>
english.lng
</edit file>

<search for>
if($MenuType == 1) {
</search for>

<add before>
#####Favorites List
%fav=(
'1' => "Favorites",
'2' => "Remove this Topic from your Favorites List?",
'3' => "Add this Topic to your Favorites List?",
'4' => "There are no Topics in your Favorites List!",
'5' => "Favorites List",
'6' => "Activate checkbox to <b><i>remove</i></b> this Topic from your Favorites List.",
'7' => "Update Favorites",
'8' => "Favorite",
'9' => "Add/Remove from Favorite List",
'10' => "Show Favorites List",
'11' => "Enable Favorites List for Members?",
'12' => "Enable Favorites List Dropdown Selector?",
'13' => "None of your Favorites are marked *NEW*",
'14' => " of your Favorites are marked *NEW*",
'15' => "Manage Your Favorites List",
'16' => "Your Current Favorites"
);
#####Favorites List

</add before>

<search for>
	$img{'notify'} = qq~<font size="1" class="imgcatbg">$txt{'131'}</font>~;
</search for>

<add after>
	$img{'favorites'} = qq~<font size="1" class="imgmenu">$fav{'1'}</font>~;
	$img{'favorr'} = qq~<font size="1" class="imgcatbg">$fav{'8'}</font>~;
	$img{'favora'} = qq~<font size="1" class="imgcatbg">$fav{'8'}</font>~;
</add after>

<search for>
	$img{'notify'} = qq~<img src="$imagesdir/notify.gif" alt="$txt{'131'}" border="0"> <font size="1" class="imgcatbg">$txt{'131'}</font>~;
</search for>

<add after>
	$img{'favorites'} = qq~<img src="$imagesdir/favorite.gif" alt="$fav{'10'}" border="0"> <font size="1" class="imgmenu">$fav{'1'}</font>~;
	$img{'favorr'} = qq~<img src="$imagesdir/favorite.gif" alt="$fav{'2'}" border="0"> <font size="1" class="imgcatbg">$fav{'8'}</font>~;
	$img{'favora'} = qq~<img src="$imagesdir/favorite.gif" alt="$fav{'3'}" border="0"> <font size="1" class="imgcatbg">$fav{'8'}</font>~;
</add after>

<edit file>
YaBB.pl
</edit file>

<search for>
	if ($action eq 'viewprofile') { require "$sourcedir/Profile.pl"; &ViewProfile; }
</search for>

<add after>
	elsif ($action eq 'favor2') { require "$sourcedir/Favor.pl"; &Favor2; }
	elsif ($action eq 'favor3') { require "$sourcedir/Favor.pl"; &Favor3; }
	elsif ($action eq 'favor4') { require "$sourcedir/Favor.pl"; &Favor4; }
	elsif ($action eq 'favshow') { require "$sourcedir/Favor.pl"; &ShowFavors; }
</add after>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
		if($enable_notification) { $yymenu .= qq~$menusep<a href="$cgi;action=shownotify">$img{'notification'}</a>~; }
</search for>

<add after>
		if($enable_favorites) { $yymenu .= qq~$menusep<a href="$cgi;action=favshow">$img{'favorites'}</a>~; }
</add after>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
sub DeleteMultiMembers {
&is_admin;
</search for>

<add after>
my(@deaduser); 
</add after>

<search for>

	unlink("$memberdir/$currentmem.dat");
</search for>

<add before>
	push(@deaduser,$currentmem);
</add before>

<search for>
$yySetLocation = qq~$scripturl?action=viewmembers~;
&redirectexit;
</search for>

<add before>
require "$sourcedir/Favor.pl";
remove_favorites(@deaduser);

</add before>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
sub ModifySettings {
	&is_admin;
</search for>

<add after>
	my($favchecked, $favdropchecked);
</add after>

<search for>
	if ($enable_notification) { $notifchecked = "checked" }
</search for>

<add after>
	if ($enable_favorites) { $favchecked = "checked" }
	if ($enable_favdrop) { $favdropchecked = "checked" }
</add after>

<search for>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'381'}</font></td>
</search for>

<add before>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fav{'11'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_favorites" $favchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$fav{'12'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_favdrop" $favdropchecked></td>
</add before>

<search for>
	# Set as 0 or 1 if box was checked or not
</search for>

<add before>
	push(@onoff, "enable_favorites", "enable_favdrop");
</add before>

<search for>
\$enable_notification = $enable_notification;		# Allow e-mail notification
</search for>

<add after>
\$enable_favorites = $enable_favorites;			# Allow Favorites Lists
\$enable_favdrop = $enable_favdrop;			# Allow Favorites Lists Dropdown selector
</add after>

<edit file>
Sources/Display.pl
</edit file>

<search for>
	$maxmessagedisplay ||= 10;
</search for>

<add after>
	my($favor, $isfavor);
</add after>

<search for>
	&jumpto;	# create the jumpto list
</search for>

<add before>
	$isfavor = '';
	if($enable_favorites && $username ne 'Guest') {
		my $startnum = $start || '0';
		$favor = qq~$menusep<a href="$cgi;action=favor2;thread=$viewnum;start=$startnum" onclick="return confirm('$fav{'3'}')">$img{'favora'}</a>~;
		if(-e "$datadir/$viewnum.fav") {
			fopen(FILE, "$datadir/$viewnum.fav");
				@favnames = <FILE>;
			fclose(FILE);
			foreach $chfav (@favnames) {
				chomp $chfav;
				if($username eq $chfav) {
					$favor = qq~$menusep<a href="$cgi;action=favor3;thread=$viewnum;start=$startnum" onclick="return confirm('$fav{'2'}')">$img{'favorr'}</a>~;
					$isfavor = qq~<IMG SRC="$imagesdir/favorite2.gif" BORDER=0 alt="$fav{'8'}">&nbsp;~;
					last;
				}
			}
		}
		$notify = $favor .= $notify;
	}

</add before>

<search for>
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<table width="100%" cellpadding="0" cellspacing="0">
</search for>

<add after>
~;
     	if( $enable_favorites && $enable_favdrop && $username ne 'Guest' ) { require "$sourcedir/Favor.pl"; &favordrop;
	$yymain .= qq~
  <tr>
    <td align="right" valign="bottom" colspan=3>$favselect</td></form>
  </tr>~;
}
	$yymain .= qq~
</add after>

<search for>
        <font size=2 class="text1" color="$color{'titletext'}"><b>&nbsp;$txt{'118'}: $msubthread</b> &nbsp;($txt{'641'} $views $txt{'642'})</font></td>
</search for>

<replace>
        <font size=2 class="text1" color="$color{'titletext'}"><b>&nbsp;$txt{'118'}: $isfavor$msubthread</b> &nbsp;($txt{'641'} $views $txt{'642'})</font></td>
</replace>

<edit file>
Sources/Profile.pl
</edit file>

<search for>

	# For security, remove username from mod position
</search for>

<add before>
		require "$sourcedir/Favor.pl";
		remove_favorites($member{'username'});
</add before>

<edit file>
Sources/MoveThread.pl
</edit file>

<search for>
				if ($1 eq 'mail' && -e "$datadir/$thread.mail") { unlink("$datadir/$thread.mail"); }
</search for>

<add after>
				if ($1 eq 'fav' && -e "$datadir/$newthreadid.fav") {
					fopen(FILE, "$datadir/$newthreadid.fav") || &fatal_error("$txt{'23'} $thread.fav");
					@favinfo = <FILE>;
					chomp @favinfo;
					$oldboard = $favinfo[0];
					chomp $oldboard;
					fclose(FILE);
					unlink("$datadir/$thread.fav"); 
					unlink("$datadir/$newthreadid.fav"); 
					require "$sourcedir/Favor.pl"; 
					$favname = '';
					foreach $curname (@favinfo) {
						$curname =~ s/[\n\r]//g;
						chomp $curname;
						if($curname ne $oldboard && -e "$memberdir/$curname.dat") {
							&favmovecheck($curname, $toboard);
							if($accessfav == 1) {$favname .= "$curname\n";}
						}
					}
					if($favname){
						fopen(NFILE, ">$datadir/$newthreadid.fav") || &fatal_error("$txt{'23'} $newthreadid.fav");
						print NFILE "$toboard\n";
						print NFILE "$favname";
						fclose(NFILE);
					}
				}
</add after>

<edit file>
Sources/RemoveThread.pl
</edit file>

<search for>
	unlink("$datadir/$thread.mail");
</search for>

<add after>
	unlink("$datadir/$thread.fav");
</add after>

<edit file>
Sources/RemoveOldThreads.pl
</edit file>

<search for>
					unlink("$datadir/$num.mail");
</search for>

<add after>
					unlink("$datadir/$num.fav");
</add after>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
			unlink("$datadir/$tnum.mail");
</search for>

<add after>
			unlink("$datadir/$tnum.fav");
</add after>

<edit file>
Sources/ManageCats.pl
</edit file>

<search for>
					unlink("$datadir/$id.mail");
</search for>

<add after>
					unlink("$datadir/$id.fav");
</add after>

<edit file>
Sources/ManageBoards.pl
</edit file>

<search for>
			unlink("$datadir/$id\.mail");
</search for>

<add after>
			unlink("$datadir/$id\.fav");
</add after>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
<table width="100%" cellpadding="0" cellspacing="0">
</search for>

<add after>
~;
     	if( $enable_favorites && $enable_favdrop && $username ne 'Guest' ) { require "$sourcedir/Favor.pl"; &favordrop;
	$yymain .= qq~
  <tr>
    <td valign=bottom align=right>$favselect</td></form>
  </tr>~;
}
	$yymain .= qq~
</add after>

<search for>
		# Print the thread info.
</search for>

<add before>
		if((-e "$datadir/$mnum.fav") && ($enable_favorites)) {
			fopen(FILE, "$datadir/$mnum.fav");
				@favnames = <FILE>;
			fclose(FILE);
			foreach $chfav (@favnames) {
				chomp $chfav;
				if($username eq $chfav) {$new .= qq~&nbsp;<IMG SRC="$imagesdir/favorite2.gif" BORDER=0 alt="$fav{'8'}">~; last;}
			}
		}

</add before>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
	$curforumurl = $curposlinks ? qq~<a href="$scripturl" class="nav">$mbname</a>~ : $mbname;
</search for>

<add after>
     	if( $enable_favorites && $enable_favdrop && $username ne 'Guest' ) { require "$sourcedir/Favor.pl"; &favordrop;
	$yymain .= qq~
<table border="0" width="100%">
  <tr>
    <td align="right" valign="bottom" colspan=2>$favselect<br><br></td></form>
  </tr>
</table>~;
	}
</add after>
